﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace CarMod
{
    public class CarMod
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "grad",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Soviet and Russian multiple rocket launcher system of 122 mm caliber. Designed to defeat open and sheltered manpower, unarmored vehicles and armored personnel carriers in the area of concentration",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {


                        Transform body = Instance.transform.GetChild(0);     


                        Transform bodyBackground = body.GetChild(0);
                        bodyBackground.localPosition = new Vector3(0.5f, -0.5f);
                        bodyBackground.gameObject.AddComponent<Optout>();



                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(-1.4f, -0.9f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.FindSpawnable("Truck").Prefab.transform.GetChild(0).GetChild(0).GetComponent<SpriteRenderer>().sprite;
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857144f;
                        wheels[0].motor = new JointMotor2D
                        {
                            maxMotorTorque = 300f
                        };
                        wheels[0].suspension = new JointSuspension2D
                        {
                            angle = 90f,
                            dampingRatio = 1f,
                            frequency = 10f
                        };
                        wheels[1].anchor = new Vector2(5.7f, -0.9f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite;
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857144f;
                        wheels[1].motor = wheels[0].motor;
                        wheels[1].suspension = wheels[0].suspension;

                        Transform body2 = Instance.transform.GetChild(3);

                        GameObject body2Background = new GameObject("Background");
                        body2Background.transform.parent = body2;
                        body2Background.transform.rotation = body2.rotation;
                        body2Background.transform.localScale = Vector3.one;
                        body2Background.FixColliders();
                        body2Background.transform.localPosition = new Vector3(-1f, 0.2f);
                        SpriteRenderer frameBackgroundRenderer = bodyBackground.gameObject.GetComponent<SpriteRenderer>();
                        SpriteRenderer body2BackgroundRenderer = body2Background.AddComponent<SpriteRenderer>();
                        body2BackgroundRenderer.sprite = ModAPI.LoadSprite("Textures/BodyBackground.png");
                        body2BackgroundRenderer.sortingOrder = frameBackgroundRenderer.sortingOrder;
                        body2BackgroundRenderer.sortingLayerName = frameBackgroundRenderer.sortingLayerName;
                        body2Background.AddComponent<Optout>();

                        Transform door = Instance.transform.GetChild(5);
                        GameObject wheel = new GameObject("Wheel3");
                        wheel.transform.parent = Instance.transform;
                        wheel.transform.rotation = Instance.transform.rotation;
                        wheel.transform.localScale = new Vector3(1.3f, 1.3f);
                        wheel.transform.localPosition = new Vector3(-2.5f, -0.42f);
                        wheel.gameObject.AddComponent<Optout>();
                        SpriteRenderer wheelRenderer = wheel.AddComponent<SpriteRenderer>();
                        wheelRenderer.sprite = wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite;
                        wheelRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        wheel.layer = 9;
                        wheel.AddComponent<CircleCollider2D>();
                        wheel.AddComponent<Rigidbody2D>().mass = 1f;
                        WheelJoint2D wheelJoint = body.gameObject.AddComponent<WheelJoint2D>();
                        wheelJoint.connectedBody = wheel.GetComponent<Rigidbody2D>();
                        wheelJoint.anchor = new Vector3(0.6f, -0.9f);
                        wheelJoint.motor = wheels[0].motor;
                        wheelJoint.suspension = wheels[0].suspension;
                        wheelJoint.breakForce = wheels[0].breakForce;
                        wheelJoint.useMotor = true;
                        wheel.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                        wheel.AddComponent<AudioSourceTimeScaleBehaviour>();
                        wheel.AddComponent<Optout>();

                        if (body.GetComponent<CarBehaviour>().WheelJoints.Length == 2)
                        {
                            List<WheelJoint2D> wheelList = body.GetComponent<CarBehaviour>().WheelJoints.ToList();
                            wheelList.Add(wheelJoint);
                            body.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                            List<bool> wheelStateList = body.GetComponent<CarBehaviour>().WheelJointState.ToList();
                            wheelStateList.Add(true);
                            body.GetComponent<CarBehaviour>().WheelJointState = wheelStateList.ToArray();
                        }
                        else if (wheelJoint)
                        {
                            List<WheelJoint2D> wheelList = wheels.ToList();
                            wheelList[2] = wheelJoint;
                            body.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                            List<bool> wheelStateList = body.GetComponent<CarBehaviour>().WheelJointState.ToList();
                            wheelStateList[2] = true;
                            body.GetComponent<CarBehaviour>().WheelJointState = wheelStateList.ToArray();
                        }
                        body.gameObject.AddComponent<CarWheelsBehaviour>().Wheels = body.GetComponent<CarBehaviour>().WheelJoints;

                        body.GetComponent<CarBehaviour>().MotorSpeed = -1000f;
                        PhysicalBehaviour phys = body.GetComponent<PhysicalBehaviour>();
                        phys.TrueInitialMass = 60f;
                        phys.InitialMass = 60f;
                        phys.rigidbody.mass = 60f;
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-0.06393433f, -0.1572786f);
                        boxColliders[0].size = new Vector2(11.157845f, 1.6576098f); // замени свой ice он за финесит по любому
                        UnityEngine.Object.Destroy(boxColliders[1]);
                        UnityEngine.Object.Destroy(boxColliders[2]);
                        UnityEngine.Object.Destroy(boxColliders[3]);


                        body2.localPosition = new Vector3(2.82857f, 1.895f);// кабина позиция
                        body2.gameObject.name = "Body2";
                        body2.gameObject.AddComponent<Optout>();
                        body2.GetComponent<SpriteRenderer>().sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        PhysicalBehaviour bodyPhys = body2.GetComponent<PhysicalBehaviour>();
                        bodyPhys.TrueInitialMass = 54f;
                        bodyPhys.InitialMass = 54f;
                        bodyPhys.rigidbody.mass = 54f;
                        FixedJoint2D bodyFixedJoint = body2.GetComponent<FixedJoint2D>();
                        bodyFixedJoint.breakForce = 10011100f;
                        bodyFixedJoint.breakTorque = 5000111f;
                        HingeJoint2D hingeJoint = body2.GetComponent<HingeJoint2D>();
                        hingeJoint.anchor = new Vector2(1.669298f, -1.625472f);
                        hingeJoint.breakForce = 5500000f;
                        hingeJoint.breakTorque = 5000000f;
                        body2.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Body.png"),
                        };
                        body2.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BodyRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        body2.gameObject.FixColliders();
                        body2.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        body2.gameObject.AddComponent<Optout>();

                        body.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Frame.png"),
                        };
                        body.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FrameRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        body.gameObject.FixColliders();
                        body.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        body.gameObject.AddComponent<Optout>();

                        door.localPosition = new Vector3(1.57f, 2.28f);
                        door.gameObject.name = "Door";
                        door.gameObject.AddComponent<Optout>();
                        door.GetComponent<FixedJoint2D>().connectedBody = body2.GetComponent<Rigidbody2D>();
                        door.GetComponent<HingeJoint2D>().connectedBody = body2.GetComponent<Rigidbody2D>();
                        door.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-1.042865f, 1.471429f),
                            new Vector2(-1.040095f, -0.8447788f),
                            new Vector2(-0.6768951f, -0.8437735f),
                            new Vector2(-0.1882877f, -1.047096f),
                            new Vector2(0.1591494f, -1.471429f),
                            new Vector2(1.042857f, -1.471429f),
                            new Vector2(1.042857f, 0.2650303f),
                            new Vector2(0.5563124f, 1.471924f)
                        });

                        door.gameObject.AddComponent<Optout>();

                        GameObject mirror = new GameObject("Mirror");
                        mirror.transform.parent = Instance.transform;
                        mirror.transform.rotation = door.rotation;
                        mirror.transform.localScale = Vector3.one;
                        mirror.transform.localPosition = new Vector3(1.8f, 2.75f);
                        SpriteRenderer mirrorRenderer = mirror.gameObject.AddComponent<SpriteRenderer>();
                        mirrorRenderer.sprite = ModAPI.LoadSprite("Textures/Mirror.png");
                        mirrorRenderer.sortingOrder = door.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        mirrorRenderer.sortingLayerName = door.GetComponent<SpriteRenderer>().sortingLayerName;
                        mirror.layer = 9;
                        mirror.AddComponent<BoxCollider2D>();
                        mirror.AddComponent<Rigidbody2D>().mass = 1f;
                        FixedJoint2D mirrorFixedJoint = mirror.AddComponent<FixedJoint2D>();
                        mirrorFixedJoint.connectedBody = door.GetComponent<Rigidbody2D>();
                        mirrorFixedJoint.frequency = 8f;
                        mirrorFixedJoint.dampingRatio = 1f;
                        mirrorFixedJoint.breakForce = 500f;
                        mirrorFixedJoint.anchor = new Vector2(0.01333714f, -0.3564899f);
                        mirror.AddComponent<JointSerialisationHelper>().Joint = mirrorFixedJoint;
                        mirror.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        mirror.AddComponent<AudioSourceTimeScaleBehaviour>();
                        mirror.AddComponent<Optout>();

                        Instance.transform.GetChild(6).gameObject.SetActive(false);

                        Transform gastank = Instance.transform.GetChild(8);
                        SpriteRenderer gastankRenderer = gastank.GetComponent<SpriteRenderer>();
                        gastankRenderer.sprite = ModAPI.LoadSprite("Textures/Gastank.png");
                        gastankRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        gastankRenderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        PhysicalBehaviour gastankPhys = gastank.GetComponent<PhysicalBehaviour>();
                        gastankPhys.TrueInitialMass = 6f;
                        gastankPhys.InitialMass = 6f;
                        gastankPhys.rigidbody.mass = 6f;
                        gastank.GetComponent<BoxCollider2D>().size = new Vector3(1.657143f, 0.4428572f);

                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Frame.png"),
                                Background = ModAPI.LoadSprite("Textures/FrameBackground.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Body.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Door.png")
                            }
                        };
                        
                        if (Instance.transform.lossyScale.x < 0)
                        {
                            HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, Instance.transform.position + new Vector3(2.6f, -0.5f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            smoke.connectedBody = body.GetComponent<Rigidbody2D>();
                            smoke.GetComponent<SpriteRenderer>().sprite = null;
                            smoke.transform.parent = body.transform;

                            HingeJoint2D light = GameObject.Instantiate(ModAPI.FindSpawnable("Spot Light").Prefab, body2.transform.position + new Vector3(-4.2f, -1.83f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            light.connectedBody = body2.GetComponent<Rigidbody2D>();
                            light.GetComponent<SpriteRenderer>().sprite = null;
                            light.transform.eulerAngles = new Vector3(0f, 0f, 90);
                            light.transform.parent = body.transform;
                            light.transform.localScale = new Vector3(0.5f, 0.5f);

                            JointAngleLimits2D limits2 = new JointAngleLimits2D();
                            limits2.min = 0f;
                            limits2.max = 0f;
                            light.limits = limits2;
                        }
                        else
                        {
                            HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, Instance.transform.position + new Vector3(-2.6f, -0.5f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            smoke.connectedBody = body.GetComponent<Rigidbody2D>();
                            smoke.GetComponent<SpriteRenderer>().sprite = null;
                            smoke.transform.parent = body.transform;

                            HingeJoint2D light = GameObject.Instantiate(ModAPI.FindSpawnable("Spot Light").Prefab, body2.transform.position + new Vector3(4.2f, -1.83f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            light.connectedBody = body2.GetComponent<Rigidbody2D>();
                            light.GetComponent<SpriteRenderer>().sprite = null;
                            light.transform.eulerAngles = new Vector3(0f, 0f, -90);
                            light.transform.parent = body.transform;
                            light.transform.localScale = new Vector3(0.5f, 0.5f);

                            JointAngleLimits2D limits2 = new JointAngleLimits2D();
                            limits2.min = 0f;
                            limits2.max = 0f;
                            light.limits = limits2;
                        }


                        body.localPosition = new Vector3(-2.7f, 1.3f);// кабина позицияad

                        wheels[0].connectedBody.transform.localPosition = new Vector3(-1.8f, -0.42f);
                        wheels[0].connectedBody.transform.localScale = new Vector3(1.3f, 1.3f);
                        wheels[1].connectedBody.transform.localPosition = new Vector3(2.4f, -0.42f);
                        wheels[1].connectedBody.transform.localScale = new Vector3(1.3f, 1.3f);
                        gastank.localPosition = new Vector3(0f, 0.85f);

                        Transform engine = Instance.transform.GetChild(7);
                        engine.localScale = new Vector3(1.3f, 1.3f);
                        engine.localPosition = new Vector3(0.1f, 1.1f);

                        
                        body.GetComponent<Rigidbody2D>().centerOfMass = new Vector2(2.67f, -0.18f);
                        if (Instance.transform.lossyScale.x < 0)
                        {
                            body.GetComponent<Rigidbody2D>().centerOfMass = new Vector2(-2.67f, -0.18f);
                        }
                        else
                        {
                            body.GetComponent<Rigidbody2D>().centerOfMass = new Vector2(2.67f, -0.18f);
                        }

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                        GameObject cannon = ModAPI.CreatePhysicalObject("cannon", ModAPI.LoadSprite("Textures/barrel.png"));
                        cannon.transform.SetParent(Instance.transform);
                        GameObject.Destroy(cannon.GetComponent<Collider2D>());
                        cannon.AddComponent<BoxCollider2D>();
                        cannon.FixColliders();
                        var Joint2 = cannon.AddComponent<HingeJoint2D>();
                        Joint2.connectedBody = body.GetComponent<Rigidbody2D>();
                        Joint2.enableCollision = true;
                        PhysicalBehaviour physicalBehaviour2 = cannon.GetComponent<PhysicalBehaviour>();
                        physicalBehaviour2.Properties = ModAPI.FindPhysicalProperties("Metal");

                        var shoota = cannon.AddComponent<ProjectileLauncherBehaviour>();
                        if (Instance.transform.lossyScale.x < 0)
                        {
                            cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(-3f, -2.5f); 
                            cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/barrelflop.png");
                            Joint2.anchor = new Vector3(3f, 0f);
                            shoota.projectileAsset = ModAPI.FindSpawnable("Grad RoundFlop");

                            JointAngleLimits2D limits = new JointAngleLimits2D();
                            limits.min = 0f;
                            limits.max = -15f;
                            Joint2.limits = limits;

                        }
                        else
                        {
                            cannon.transform.position = (Vector2)Instance.transform.position - new Vector2(3f, -2.5f); 
                            cannon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/barrel.png");
                            shoota.projectileAsset = ModAPI.FindSpawnable("Grad Round");
                            Joint2.anchor = new Vector3(-3f, 0f);

                            JointAngleLimits2D limits = new JointAngleLimits2D();
                            limits.min = -15f;
                            limits.max = 0f;
                            Joint2.limits = limits;
                        }
                        JointMotor2D motor = new JointMotor2D();
                        motor.maxMotorTorque = 50;
                        cannon.GetComponent<HingeJoint2D>().motor = motor;
                        JointMotor2D motor2 = new JointMotor2D();
                        motor2.maxMotorTorque = 10;

                        shoota.recoilMultiplier = 2.5f;

                        shoota.ScreenShake = 1337f;
                        shoota.IsAutomatic = true;
                        shoota.AutomaticInterval = 1;
                        shoota.launchSound = ModAPI.LoadSound("sounds/shoot.wav");

                        if (Instance.transform.lossyScale.x < 0)
                        {
                            shoota.projectileLaunchStrength = -40f;
                            shoota.barrelPosition = new Vector2(-3f, 0.5f);
                        }
                        else
                        {
                            shoota.projectileLaunchStrength = 40f;
                            shoota.barrelPosition = new Vector2(3f, 0.5f);
                        }

                        var allColliders = Instance.GetComponentsInChildren<Collider2D>();
                        foreach (var a in allColliders)
                            foreach (var b in allColliders)
                                Physics2D.IgnoreCollision(a, b);

                        cannon.AddComponent<fcOnFireGarbage>();
                        var fc = cannon.GetComponent<fcOnFireGarbage>();
                        fc.Cannon = cannon;

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("General Purpose Bomb"),
                    NameOverride = "Grad Round",
                    DescriptionOverride = "A highly fragile explosive round.",
                    CategoryOverride = ModAPI.FindCategory("none"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/blingus.png");
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<ExplosiveBehaviour>().Range = 5f;
                        Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 0.000000000001f;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 100;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.3f;
                        Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 1f;
                        Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 200f;

                        AudioSource src = Instance.gameObject.AddComponent<AudioSource>();
                        src.clip = ModAPI.LoadSound("sounds/rocketFly.wav");
                        src.Play();
                        src.loop = true;


                        HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<HingeJoint2D>();
                        smoke.connectedBody = Instance.GetComponent<Rigidbody2D>();
                        smoke.GetComponent<SpriteRenderer>().sprite = null;
                        smoke.transform.parent = Instance.transform;
                        smoke.transform.localPosition = new Vector3(-1.5f, -0.2f);
                        smoke.GetComponent<ParticleMachineBehaviour>().Activated = true;
                        smoke.GetComponent<ParticleMachineBehaviour>().EmitFire = true;
                        smoke.GetComponent<PhysicalBehaviour>().transform.localScale = new Vector3(3.5f, 3.5f);
                        Instance.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Blingus.png"),
                        };
                        Instance.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/blingusRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.gameObject.FixColliders();
                        Instance.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        Instance.gameObject.AddComponent<Optout>();

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("General Purpose Bomb"),
                    NameOverride = "Grad RoundFlop",
                    DescriptionOverride = "A highly fragile explosive round.",
                    CategoryOverride = ModAPI.FindCategory("none"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/blingus.png");
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<ExplosiveBehaviour>().Range = 5f;
                        Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 0.000000000001f;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 100;
                        Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.3f;
                        Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 1f;
                        Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 200f;
                        Instance.transform.localScale = new Vector3(-1f, 1f, 1f);

                        AudioSource src = Instance.gameObject.AddComponent<AudioSource>();
                        src.clip = ModAPI.LoadSound("sounds/rocketFly.wav");
                        src.Play();
                        src.loop = true;


                        HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<HingeJoint2D>();
                        smoke.connectedBody = Instance.GetComponent<Rigidbody2D>();
                        smoke.GetComponent<SpriteRenderer>().sprite = null;
                        smoke.transform.parent = Instance.transform;
                        smoke.transform.localPosition = new Vector3(-1.5f, -0.2f);
                        smoke.GetComponent<ParticleMachineBehaviour>().Activated = true;
                        smoke.GetComponent<ParticleMachineBehaviour>().EmitFire = true;
                        smoke.GetComponent<PhysicalBehaviour>().transform.localScale = new Vector3(3.5f, 3.5f);
                        smoke.GetComponent<PhysicalBehaviour>().IsWeightless = true;
                        Instance.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Blingus.png"),
                        };
                        Instance.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/blingusRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.gameObject.FixColliders();
                        Instance.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        Instance.gameObject.AddComponent<Optout>();
                    }
                }
            );

        }
    }

    [SkipSerialisation]
    public class fcOnFireGarbage : MonoBehaviour
    {
        public GameObject Cannon;
        public Vector3 corner_position_offset;
        public Vector4 corner_position_offset2;

        float frequency = 0.15f;
        int missileCount = 40;
        float currentTime = 0f;
        int currentCount = 0;
        bool wait = false;
        ProjectileLauncherBehaviour plb;

        void Start()
        {
            plb = GetComponent<ProjectileLauncherBehaviour>();
            plb.enabled = false;
            currentTime = frequency;

            //ModAPI.Notify("aaa");
            corner_position_offset = new Vector3(0, 0, 0);
            corner_position_offset2 = new Vector3(0, 0, 0);

            if (Cannon.transform.parent.gameObject.transform.lossyScale.x < 0)
            {
                corner_position_offset = new Vector3(4, 0, 0);
                corner_position_offset2 = new Vector4(-3, 0, 0);
                //ModAPI.Notify("First");
            }
            else
            {
                corner_position_offset = new Vector3(-4, 0, 0);
                corner_position_offset2 = new Vector4(3, 0, 0);
                //ModAPI.Notify("Second");
            }

        }

        void Update()
        {
            if (wait)
            {
                currentTime += Time.deltaTime;
                if (currentTime >= frequency)
                {
                    plb.enabled = true;
                    plb.Launch();
                    Use();
                    plb.enabled = false;
                    currentTime = 0f;
                    currentCount++;
                    if (currentCount == missileCount)
                    {
                        wait = false;
                        currentCount = 0;
                        currentTime = frequency;
                    }
                }
            }
        }

        void Use()
        {
            wait = true;

            ModAPI.CreateParticleEffect("BlasterImpact", Cannon.transform.position + (Cannon.transform.rotation * corner_position_offset)).transform.localScale = new Vector4(30f, -20f);
            ModAPI.CreateParticleEffect("BigExplosion", Cannon.transform.position + (Cannon.transform.rotation * corner_position_offset));

            ModAPI.CreateParticleEffect("FuseBlown", Cannon.transform.position + (Cannon.transform.rotation * corner_position_offset2)).transform.localScale = new Vector3(10.12f, -5.12f);
        }

    }


    
    public class CarWheelsBehaviour : MonoBehaviour
    {
        private void OnJointBreak2D(Joint2D joint)
        {
            if (Wheels.Contains(joint))
            {
                joint.connectedBody.transform.parent = transform.parent;
            }
        }

        [SkipSerialisation]
        public WheelJoint2D[] Wheels = new WheelJoint2D[0];
    }

}